Index: branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 530)
+++ branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 531)
@@ -1448,71 +1739,87 @@
      * Else fallback to the initial method using the xml file to write in ...
      */
-    char ntmp[1024];
+      char ntmp[1024];
 #ifndef WIN32
-    getcwd(ntmp,1024);
+      getcwd (ntmp, 1024);
 #else
-    _getcwd(ntmp,1024);
-#endif
-    struct stat myFileInfo;
-    int statRes;
-    char file_path[1024];
-    sprintf(file_path,"%s/GetStatus.zcfg",ntmp);
-    statRes=stat(file_path,&myFileInfo);
-    if(statRes==0){
-      char currentSid[128];
-      map* tmpm=getMap(tmp_maps->content,"rewriteUrl");
-      map *tmp_lenv=NULL;
-      tmp_lenv=getMapFromMaps(m,"lenv","sid");
-      if(tmp_lenv==NULL)
-	sprintf(currentSid,"%i",pid);
+      _getcwd (ntmp, 1024);
+#endif
+      struct stat myFileInfo;
+      int statRes;
+      char file_path[1024];
+      sprintf (file_path, "%s/GetStatus.zcfg", ntmp);
+      statRes = stat (file_path, &myFileInfo);
+      if (statRes == 0)
+        {
+          char currentSid[128];
+          map *tmpm = getMap (tmp_maps->content, "rewriteUrl");
+          map *tmp_lenv = NULL;
+          tmp_lenv = getMapFromMaps (m, "lenv", "sid");
+          if (tmp_lenv == NULL)
+            sprintf (currentSid, "%i", pid);
+          else
+            sprintf (currentSid, "%s", tmp_lenv->value);
+          if (tmpm == NULL || strcasecmp (tmpm->value, "false") == 0)
+            {
+              sprintf (url,
+                       "%s?request=Execute&service=WPS&version=1.0.0&Identifier=GetStatus&DataInputs=sid=%s&RawDataOutput=Result",
+                       tmpm1->value, currentSid);
+            }
+          else
+            {
+              if (strlen (tmpm->value) > 0)
+                if (strcasecmp (tmpm->value, "true") != 0)
+                  sprintf (url, "%s/%s/GetStatus/%s", tmpm1->value,
+                           tmpm->value, currentSid);
+                else
+                  sprintf (url, "%s/GetStatus/%s", tmpm1->value, currentSid);
+              else
+                sprintf (url,
+                         "%s/?request=Execute&service=WPS&version=1.0.0&Identifier=GetStatus&DataInputs=sid=%s&RawDataOutput=Result",
+                         tmpm1->value, currentSid);
+            }
+        }
       else
-	sprintf(currentSid,"%s",tmp_lenv->value);
-      if(tmpm==NULL || strcasecmp(tmpm->value,"false")==0){
-	sprintf(url,"%s?request=Execute&service=WPS&version=1.0.0&Identifier=GetStatus&DataInputs=sid=%s&RawDataOutput=Result",tmpm1->value,currentSid);
-      }else{
-	if(strlen(tmpm->value)>0)
-	  if(strcasecmp(tmpm->value,"true")!=0)
-	    sprintf(url,"%s/%s/GetStatus/%s",tmpm1->value,tmpm->value,currentSid);
-	  else
-	    sprintf(url,"%s/GetStatus/%s",tmpm1->value,currentSid);
-	else
-	  sprintf(url,"%s/?request=Execute&service=WPS&version=1.0.0&Identifier=GetStatus&DataInputs=sid=%s&RawDataOutput=Result",tmpm1->value,currentSid);
-      }
-    }else{
-      map* tmpm2=getMap(tmp_maps->content,"tmpUrl");
-      if(tmpm1!=NULL && tmpm2!=NULL){
-	if( strncasecmp( tmpm2->value, "http://", 7) == 0 ||
-	    strncasecmp( tmpm2->value, "https://", 8 ) == 0 ){
-	  sprintf(url,"%s/%s_%i.xml",tmpm2->value,service,pid);
-	}else
-	  sprintf(url,"%s/%s/%s_%i.xml",tmpm1->value,tmpm2->value,service,pid);
-      }
-    }
-    if(tmpm1!=NULL)
-      sprintf(tmp,"%s",tmpm1->value);
-    tmpm1=getMapFromMaps(m,"main","TmpPath");
-    sprintf(stored_path,"%s/%s_%i.xml",tmpm1->value,service,pid);
-  }
-
-
-
-  xmlNewProp(n,BAD_CAST "serviceInstance",BAD_CAST tmp);
-  map* test=getMap(request,"storeExecuteResponse");
-  bool hasStoredExecuteResponse=false;
-  if(test!=NULL && strcasecmp(test->value,"true")==0){
-    xmlNewProp(n,BAD_CAST "statusLocation",BAD_CAST url);
-    hasStoredExecuteResponse=true;
-  }
-
-  nc = xmlNewNode(ns, BAD_CAST "Process");
-  map* tmp2=getMap(serv->content,"processVersion");
-  if(tmp2!=NULL)
-    xmlNewNsProp(nc,ns,BAD_CAST "processVersion",BAD_CAST tmp2->value);
-  
-  printDescription(nc,ns_ows,serv->name,serv->content);
-
-  xmlAddChild(n,nc);
-
-  nc = xmlNewNode(ns, BAD_CAST "Status");
+        {
+          map *tmpm2 = getMap (tmp_maps->content, "tmpUrl");
+          if (tmpm1 != NULL && tmpm2 != NULL)
+            {
+              if (strncasecmp (tmpm2->value, "http://", 7) == 0 ||
+                  strncasecmp (tmpm2->value, "https://", 8) == 0)
+                {
+                  sprintf (url, "%s/%s_%i.xml", tmpm2->value, service, pid);
+                }
+              else
+                sprintf (url, "%s/%s/%s_%i.xml", tmpm1->value, tmpm2->value,
+                         service, pid);
+            }
+        }
+      if (tmpm1 != NULL)
+        sprintf (tmp, "%s", tmpm1->value);
+      tmpm1 = getMapFromMaps (m, "main", "TmpPath");
+      sprintf (stored_path, "%s/%s_%i.xml", tmpm1->value, service, pid);
+    }
+
+
+
+  xmlNewProp (n, BAD_CAST "serviceInstance", BAD_CAST tmp);
+  map *test = getMap (request, "storeExecuteResponse");
+  bool hasStoredExecuteResponse = false;
+  if (test != NULL && strcasecmp (test->value, "true") == 0)
+    {
+      xmlNewProp (n, BAD_CAST "statusLocation", BAD_CAST url);
+      hasStoredExecuteResponse = true;
+    }
+
+  nc = xmlNewNode (ns, BAD_CAST "Process");
+  map *tmp2 = getMap (serv->content, "processVersion");
+  if (tmp2 != NULL)
+    xmlNewNsProp (nc, ns, BAD_CAST "processVersion", BAD_CAST tmp2->value);
+
+  printDescription (nc, ns_ows, serv->name, serv->content);
+
+  xmlAddChild (n, nc);
+
+  nc = xmlNewNode (ns, BAD_CAST "Status");
   const struct tm *tm;
   size_t len;
@@ -1520,96 +1827,109 @@
   char *tmp1;
   map *tmpStatus;
-  
-  now = time ( NULL );
-  tm = localtime ( &now );
-
-  tmp1 = (char*)malloc((TIME_SIZE+1)*sizeof(char));
-
-  len = strftime ( tmp1, TIME_SIZE, "%Y-%m-%dT%I:%M:%SZ", tm );
-
-  xmlNewProp(nc,BAD_CAST "creationTime",BAD_CAST tmp1);
+
+  now = time (NULL);
+  tm = localtime (&now);
+
+  tmp1 = (char *) malloc ((TIME_SIZE + 1) * sizeof (char));
+
+  len = strftime (tmp1, TIME_SIZE, "%Y-%m-%dT%I:%M:%SZ", tm);
+
+  xmlNewProp (nc, BAD_CAST "creationTime", BAD_CAST tmp1);
 
   char sMsg[2048];
-  switch(status){
-  case SERVICE_SUCCEEDED:
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessSucceeded");
-    sprintf(sMsg,_("Service \"%s\" run successfully."),serv->name);
-    nc3=xmlNewText(BAD_CAST sMsg);
-    xmlAddChild(nc1,nc3);
-    break;
-  case SERVICE_STARTED:
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessStarted");
-    tmpStatus=getMapFromMaps(m,"lenv","status");
-    xmlNewProp(nc1,BAD_CAST "percentCompleted",BAD_CAST tmpStatus->value);
-    sprintf(sMsg,_("ZOO Service \"%s\" is currently running. Please, reload this document to get the up-to-date status of the Service."),serv->name);
-    nc3=xmlNewText(BAD_CAST sMsg);
-    xmlAddChild(nc1,nc3);
-    break;
-  case SERVICE_ACCEPTED:
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessAccepted");
-    sprintf(sMsg,_("Service \"%s\" was accepted by the ZOO Kernel and it run as a background task. Please consult the statusLocation attribtue providen in this document to get the up-to-date document."),serv->name);
-    nc3=xmlNewText(BAD_CAST sMsg);
-    xmlAddChild(nc1,nc3);
-    break;
-  case SERVICE_FAILED:
-    nc1 = xmlNewNode(ns, BAD_CAST "ProcessFailed");
-    map *errorMap;
-    map *te;
-    te=getMapFromMaps(m,"lenv","code");
-    if(te!=NULL)
-      errorMap=createMap("code",te->value);
-    else
-      errorMap=createMap("code","NoApplicableCode");
-    te=getMapFromMaps(m,"lenv","message");
-    if(te!=NULL)
-      addToMap(errorMap,"text",_ss(te->value));
-    else
-      addToMap(errorMap,"text",_("No more information available"));
-    nc3=createExceptionReportNode(m,errorMap,0);
-    freeMap(&errorMap);
-    free(errorMap);
-    xmlAddChild(nc1,nc3);
-    break;
-  default :
-    printf(_("error code not know : %i\n"),status);
-    //exit(1);
-    break;
-  }
-  xmlAddChild(nc,nc1);
-  xmlAddChild(n,nc);
-  free(tmp1);
+  switch (status)
+    {
+    case SERVICE_SUCCEEDED:
+      nc1 = xmlNewNode (ns, BAD_CAST "ProcessSucceeded");
+      sprintf (sMsg, _("Service \"%s\" run successfully."), serv->name);
+      nc3 = xmlNewText (BAD_CAST sMsg);
+      xmlAddChild (nc1, nc3);
+      break;
+    case SERVICE_STARTED:
+      nc1 = xmlNewNode (ns, BAD_CAST "ProcessStarted");
+      tmpStatus = getMapFromMaps (m, "lenv", "status");
+      xmlNewProp (nc1, BAD_CAST "percentCompleted",
+                  BAD_CAST tmpStatus->value);
+      sprintf (sMsg,
+               _
+               ("ZOO Service \"%s\" is currently running. Please, reload this document to get the up-to-date status of the Service."),
+               serv->name);
+      nc3 = xmlNewText (BAD_CAST sMsg);
+      xmlAddChild (nc1, nc3);
+      break;
+    case SERVICE_ACCEPTED:
+      nc1 = xmlNewNode (ns, BAD_CAST "ProcessAccepted");
+      sprintf (sMsg,
+               _
+               ("Service \"%s\" was accepted by the ZOO Kernel and it run as a background task. Please consult the statusLocation attribtue providen in this document to get the up-to-date document."),
+               serv->name);
+      nc3 = xmlNewText (BAD_CAST sMsg);
+      xmlAddChild (nc1, nc3);
+      break;
+    case SERVICE_FAILED:
+      nc1 = xmlNewNode (ns, BAD_CAST "ProcessFailed");
+      map *errorMap;
+      map *te;
+      te = getMapFromMaps (m, "lenv", "code");
+      if (te != NULL)
+        errorMap = createMap ("code", te->value);
+      else
+        errorMap = createMap ("code", "NoApplicableCode");
+      te = getMapFromMaps (m, "lenv", "message");
+      if (te != NULL)
+        addToMap (errorMap, "text", _ss (te->value));
+      else
+        addToMap (errorMap, "text", _("No more information available"));
+      nc3 = createExceptionReportNode (m, errorMap, 0);
+      freeMap (&errorMap);
+      free (errorMap);
+      xmlAddChild (nc1, nc3);
+      break;
+    default:
+      printf (_("error code not know : %i\n"), status);
+      //exit(1);
+      break;
+    }
+  xmlAddChild (nc, nc1);
+  xmlAddChild (n, nc);
+  free (tmp1);
 
 #ifdef DEBUG
-  fprintf(stderr,"printProcessResponse 1 161\n");
-#endif
-
-  map* lineage=getMap(request,"lineage");
-  if(lineage!=NULL && strcasecmp(lineage->value,"true")==0){
-    nc = xmlNewNode(ns, BAD_CAST "DataInputs");
-    maps* mcursor=inputs;
-    elements* scursor=NULL;
-    while(mcursor!=NULL /*&& scursor!=NULL*/){
-      scursor=getElements(serv->inputs,mcursor->name);
-      printIOType(doc,nc,ns,ns_ows,ns_xlink,scursor,mcursor,"Input");
-      mcursor=mcursor->next;
-    }
-    xmlAddChild(n,nc);
-    
+  fprintf (stderr, "printProcessResponse 1 161\n");
+#endif
+
+  map *lineage = getMap (request, "lineage");
+  if (lineage != NULL && strcasecmp (lineage->value, "true") == 0)
+    {
+      nc = xmlNewNode (ns, BAD_CAST "DataInputs");
+      maps *mcursor = inputs;
+      elements *scursor = NULL;
+      while (mcursor != NULL /*&& scursor!=NULL */ )
+        {
+          scursor = getElements (serv->inputs, mcursor->name);
+          printIOType (doc, nc, ns, ns_ows, ns_xlink, scursor, mcursor,
+                       "Input");
+          mcursor = mcursor->next;
+        }
+      xmlAddChild (n, nc);
+
 #ifdef DEBUG
-    fprintf(stderr,"printProcessResponse 1 177\n");
-#endif
-
-    nc = xmlNewNode(ns, BAD_CAST "OutputDefinitions");
-    mcursor=outputs;
-    scursor=NULL;
-    while(mcursor!=NULL){
-      scursor=getElements(serv->outputs,mcursor->name);
-      printOutputDefinitions1(doc,nc,ns,ns_ows,scursor,mcursor,"Output");
-      mcursor=mcursor->next;
-    }
-    xmlAddChild(n,nc);
-  }
+      fprintf (stderr, "printProcessResponse 1 177\n");
+#endif
+
+      nc = xmlNewNode (ns, BAD_CAST "OutputDefinitions");
+      mcursor = outputs;
+      scursor = NULL;
+      while (mcursor != NULL)
+        {
+          scursor = getElements (serv->outputs, mcursor->name);
+          printOutputDefinitions1 (doc, nc, ns, ns_ows, scursor, mcursor,
+                                   "Output");
+          mcursor = mcursor->next;
+        }
+      xmlAddChild (n, nc);
+    }
 #ifdef DEBUG
-  fprintf(stderr,"printProcessResponse 1 190\n");
+  fprintf (stderr, "printProcessResponse 1 190\n");
 #endif
 
@@ -1617,75 +1937,90 @@
    * Display the process output only when requested !
    */
-  if(status==SERVICE_SUCCEEDED){
-    nc = xmlNewNode(ns, BAD_CAST "ProcessOutputs");
-    maps* mcursor=outputs;
-    elements* scursor=serv->outputs;
-    map* testResponse=getMap(request,"RawDataOutput");
-    if(testResponse==NULL)
-      testResponse=getMap(request,"ResponseDocument");
-    while(mcursor!=NULL){
-      map* tmp0=getMap(mcursor->content,"inRequest");
-      scursor=getElements(serv->outputs,mcursor->name);
-      if(scursor!=NULL){
-	if(testResponse==NULL || tmp0==NULL)
-	  printIOType(doc,nc,ns,ns_ows,ns_xlink,scursor,mcursor,"Output");
-	else
-	  if(tmp0!=NULL && strncmp(tmp0->value,"true",4)==0)
-	    printIOType(doc,nc,ns,ns_ows,ns_xlink,scursor,mcursor,"Output");
-      }else
-	/**
+  if (status == SERVICE_SUCCEEDED)
+    {
+      nc = xmlNewNode (ns, BAD_CAST "ProcessOutputs");
+      maps *mcursor = outputs;
+      elements *scursor = serv->outputs;
+      map *testResponse = getMap (request, "RawDataOutput");
+      if (testResponse == NULL)
+        testResponse = getMap (request, "ResponseDocument");
+      while (mcursor != NULL)
+        {
+          map *tmp0 = getMap (mcursor->content, "inRequest");
+          scursor = getElements (serv->outputs, mcursor->name);
+          if (scursor != NULL)
+            {
+              if (testResponse == NULL || tmp0 == NULL)
+                printIOType (doc, nc, ns, ns_ows, ns_xlink, scursor, mcursor,
+                             "Output");
+              else if (tmp0 != NULL && strncmp (tmp0->value, "true", 4) == 0)
+                printIOType (doc, nc, ns, ns_ows, ns_xlink, scursor, mcursor,
+                             "Output");
+            }
+          else
+        /**
 	 * In case there was no definition found in the ZCFG file but 
 	 * present in the service code
 	 */
-	printIOType(doc,nc,ns,ns_ows,ns_xlink,scursor,mcursor,"Output");
-      mcursor=mcursor->next;
-    }
-    xmlAddChild(n,nc);
-  }
+            printIOType (doc, nc, ns, ns_ows, ns_xlink, scursor, mcursor,
+                         "Output");
+          mcursor = mcursor->next;
+        }
+      xmlAddChild (n, nc);
+    }
 
 #ifdef DEBUG
-  fprintf(stderr,"printProcessResponse 1 202\n");
-#endif
-  nr=soapEnvelope(m,n);
-  xmlDocSetRootElement(doc, nr);
-
-  if(hasStoredExecuteResponse==true){
-    /* We need to write the ExecuteResponse Document somewhere */
-    FILE* output=fopen(stored_path,"w");
-    if(output==NULL){
-      /* If the file cannot be created return an ExceptionReport */
-      char tmpMsg[1024];
-      sprintf(tmpMsg,_("Unable to create the file : \"%s\" for storing the ExecuteResponse."),stored_path);
-      map * errormap = createMap("text",tmpMsg);
-      addToMap(errormap,"code", "InternalError");
-      printExceptionReportResponse(m,errormap);
-      freeMap(&errormap);
-      free(errormap);
-      xmlFreeDoc(doc);
-      xmlCleanupParser();
-      zooXmlCleanupNs();
-      return;
-    }
-    xmlChar *xmlbuff;
-    int buffersize;
-    xmlDocDumpFormatMemoryEnc(doc, &xmlbuff, &buffersize, "UTF-8", 1);
-    fwrite(xmlbuff,1,xmlStrlen(xmlbuff)*sizeof(char),output);
-    xmlFree(xmlbuff);
-    fclose(output);
-  }
-  printDocument(m,doc,pid);
-
-  xmlCleanupParser();
-  zooXmlCleanupNs();
-}
-
-
-void printDocument(maps* m, xmlDocPtr doc,int pid){
-  char *encoding=getEncoding(m);
-  if(pid==getpid()){
-    printHeaders(m);
-    printf("Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",encoding);
-  }
-  fflush(stdout);
+  fprintf (stderr, "printProcessResponse 1 202\n");
+#endif
+  nr = soapEnvelope (m, n);
+  xmlDocSetRootElement (doc, nr);
+
+  if (hasStoredExecuteResponse == true)
+    {
+      /* We need to write the ExecuteResponse Document somewhere */
+      FILE *output = fopen (stored_path, "w");
+      if (output == NULL)
+        {
+          /* If the file cannot be created return an ExceptionReport */
+          char tmpMsg[1024];
+          sprintf (tmpMsg,
+                   _
+                   ("Unable to create the file : \"%s\" for storing the ExecuteResponse."),
+                   stored_path);
+          map *errormap = createMap ("text", tmpMsg);
+          addToMap (errormap, "code", "InternalError");
+          printExceptionReportResponse (m, errormap);
+          freeMap (&errormap);
+          free (errormap);
+          xmlFreeDoc (doc);
+          xmlCleanupParser ();
+          zooXmlCleanupNs ();
+          return;
+        }
+      xmlChar *xmlbuff;
+      int buffersize;
+      xmlDocDumpFormatMemoryEnc (doc, &xmlbuff, &buffersize, "UTF-8", 1);
+      fwrite (xmlbuff, 1, xmlStrlen (xmlbuff) * sizeof (char), output);
+      xmlFree (xmlbuff);
+      fclose (output);
+    }
+  printDocument (m, doc, pid);
+
+  xmlCleanupParser ();
+  zooXmlCleanupNs ();
+}
+
+
+void
+printDocument (maps * m, xmlDocPtr doc, int pid)
+{
+  char *encoding = getEncoding (m);
+  if (pid == getpid ())
+    {
+      printHeaders (m);
+      printf ("Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",
+              encoding);
+    }
+  fflush (stdout);
   xmlChar *xmlbuff;
   int buffersize;
@@ -1694,119 +2029,136 @@
    * for demonstration purposes.
    */
-  xmlDocDumpFormatMemoryEnc(doc, &xmlbuff, &buffersize, encoding, 1);
-  printf("%s",xmlbuff);
-  fflush(stdout);
+  xmlDocDumpFormatMemoryEnc (doc, &xmlbuff, &buffersize, encoding, 1);
+  printf ("%s", xmlbuff);
+  fflush (stdout);
   /*
    * Free associated memory.
    */
-  xmlFree(xmlbuff);
-  xmlFreeDoc(doc);
-  xmlCleanupParser();
-  zooXmlCleanupNs();
-}
-
-void printOutputDefinitions1(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,elements* e,maps* m,const char* type){
+  xmlFree (xmlbuff);
+  xmlFreeDoc (doc);
+  xmlCleanupParser ();
+  zooXmlCleanupNs ();
+}
+
+void
+printOutputDefinitions1 (xmlDocPtr doc, xmlNodePtr nc, xmlNsPtr ns_wps,
+                         xmlNsPtr ns_ows, elements * e, maps * m,
+                         const char *type)
+{
   xmlNodePtr nc1;
-  nc1=xmlNewNode(ns_wps, BAD_CAST type);
-  map *tmp=NULL;  
-  if(e!=NULL && e->defaults!=NULL)
-    tmp=e->defaults->content;
-  else{
-    /*
-    dumpElements(e);
-    */
-    return;
-  }
-  while(tmp!=NULL){
-    if(strncasecmp(tmp->name,"MIMETYPE",strlen(tmp->name))==0
-       || strncasecmp(tmp->name,"ENCODING",strlen(tmp->name))==0
-       || strncasecmp(tmp->name,"SCHEMA",strlen(tmp->name))==0
-       || strncasecmp(tmp->name,"UOM",strlen(tmp->name))==0)
-    xmlNewProp(nc1,BAD_CAST tmp->name,BAD_CAST tmp->value);
-    tmp=tmp->next;
-  }
-  tmp=getMap(e->defaults->content,"asReference");
-  if(tmp==NULL)
-    xmlNewProp(nc1,BAD_CAST "asReference",BAD_CAST "false");
-
-  tmp=e->content;
-
-  printDescription(nc1,ns_ows,m->name,e->content);
-
-  xmlAddChild(nc,nc1);
-
-}
-
-void printOutputDefinitions(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,elements* e,map* m,const char* type){
+  nc1 = xmlNewNode (ns_wps, BAD_CAST type);
+  map *tmp = NULL;
+  if (e != NULL && e->defaults != NULL)
+    tmp = e->defaults->content;
+  else
+    {
+      /*
+         dumpElements(e);
+       */
+      return;
+    }
+  while (tmp != NULL)
+    {
+      if (strncasecmp (tmp->name, "MIMETYPE", strlen (tmp->name)) == 0
+          || strncasecmp (tmp->name, "ENCODING", strlen (tmp->name)) == 0
+          || strncasecmp (tmp->name, "SCHEMA", strlen (tmp->name)) == 0
+          || strncasecmp (tmp->name, "UOM", strlen (tmp->name)) == 0)
+        xmlNewProp (nc1, BAD_CAST tmp->name, BAD_CAST tmp->value);
+      tmp = tmp->next;
+    }
+  tmp = getMap (e->defaults->content, "asReference");
+  if (tmp == NULL)
+    xmlNewProp (nc1, BAD_CAST "asReference", BAD_CAST "false");
+
+  tmp = e->content;
+
+  printDescription (nc1, ns_ows, m->name, e->content);
+
+  xmlAddChild (nc, nc1);
+
+}
+
+void
+printOutputDefinitions (xmlDocPtr doc, xmlNodePtr nc, xmlNsPtr ns_wps,
+                        xmlNsPtr ns_ows, elements * e, map * m,
+                        const char *type)
+{
   xmlNodePtr nc1;
-  nc1=xmlNewNode(ns_wps, BAD_CAST type);
-  map *tmp=NULL;  
-  if(e!=NULL && e->defaults!=NULL)
-    tmp=e->defaults->content;
-  else{
-    /*
-    dumpElements(e);
-    */
-    return;
-  }
-  while(tmp!=NULL){
-    xmlNewProp(nc1,BAD_CAST tmp->name,BAD_CAST tmp->value);
-    tmp=tmp->next;
-  }
-  tmp=getMap(e->defaults->content,"asReference");
-  if(tmp==NULL)
-    xmlNewProp(nc1,BAD_CAST "asReference",BAD_CAST "false");
-
-  tmp=e->content;
-
-  printDescription(nc1,ns_ows,m->name,e->content);
-
-  xmlAddChild(nc,nc1);
-
-}
-
-void printIOType(xmlDocPtr doc,xmlNodePtr nc,xmlNsPtr ns_wps,xmlNsPtr ns_ows,xmlNsPtr ns_xlink,elements* e,maps* m,const char* type){
-  xmlNodePtr nc1,nc2,nc3;
-  nc1=xmlNewNode(ns_wps, BAD_CAST type);
-  map *tmp=NULL;
-  if(e!=NULL)
-    tmp=e->content;
+  nc1 = xmlNewNode (ns_wps, BAD_CAST type);
+  map *tmp = NULL;
+  if (e != NULL && e->defaults != NULL)
+    tmp = e->defaults->content;
   else
-    tmp=m->content;
+    {
+      /*
+         dumpElements(e);
+       */
+      return;
+    }
+  while (tmp != NULL)
+    {
+      xmlNewProp (nc1, BAD_CAST tmp->name, BAD_CAST tmp->value);
+      tmp = tmp->next;
+    }
+  tmp = getMap (e->defaults->content, "asReference");
+  if (tmp == NULL)
+    xmlNewProp (nc1, BAD_CAST "asReference", BAD_CAST "false");
+
+  tmp = e->content;
+
+  printDescription (nc1, ns_ows, m->name, e->content);
+
+  xmlAddChild (nc, nc1);
+
+}
+
+void
+printIOType (xmlDocPtr doc, xmlNodePtr nc, xmlNsPtr ns_wps, xmlNsPtr ns_ows,
+             xmlNsPtr ns_xlink, elements * e, maps * m, const char *type)
+{
+  xmlNodePtr nc1, nc2, nc3;
+  nc1 = xmlNewNode (ns_wps, BAD_CAST type);
+  map *tmp = NULL;
+  if (e != NULL)
+    tmp = e->content;
+  else
+    tmp = m->content;
 #ifdef DEBUG
-  dumpMap(tmp);
-  dumpElements(e);
-#endif
-  nc2=xmlNewNode(ns_ows, BAD_CAST "Identifier");
-  if(e!=NULL)
-    nc3=xmlNewText(BAD_CAST e->name);
+  dumpMap (tmp);
+  dumpElements (e);
+#endif
+  nc2 = xmlNewNode (ns_ows, BAD_CAST "Identifier");
+  if (e != NULL)
+    nc3 = xmlNewText (BAD_CAST e->name);
   else
-    nc3=xmlNewText(BAD_CAST m->name);
-  xmlAddChild(nc2,nc3);
-  xmlAddChild(nc1,nc2);
-  xmlAddChild(nc,nc1);
-  if(e!=NULL)
-    tmp=getMap(e->content,"Title");
+    nc3 = xmlNewText (BAD_CAST m->name);
+  xmlAddChild (nc2, nc3);
+  xmlAddChild (nc1, nc2);
+  xmlAddChild (nc, nc1);
+  if (e != NULL)
+    tmp = getMap (e->content, "Title");
   else
-    tmp=getMap(m->content,"Title");
-  
-  if(tmp!=NULL){
-    nc2=xmlNewNode(ns_ows, BAD_CAST tmp->name);
-    nc3=xmlNewText(BAD_CAST _ss(tmp->value));
-    xmlAddChild(nc2,nc3);  
-    xmlAddChild(nc1,nc2);
-  }
-
-  if(e!=NULL)
-    tmp=getMap(e->content,"Abstract");
+    tmp = getMap (m->content, "Title");
+
+  if (tmp != NULL)
+    {
+      nc2 = xmlNewNode (ns_ows, BAD_CAST tmp->name);
+      nc3 = xmlNewText (BAD_CAST _ss (tmp->value));
+      xmlAddChild (nc2, nc3);
+      xmlAddChild (nc1, nc2);
+    }
+
+  if (e != NULL)
+    tmp = getMap (e->content, "Abstract");
   else
-    tmp=getMap(m->content,"Abstract");
-  if(tmp!=NULL){
-    nc2=xmlNewNode(ns_ows, BAD_CAST tmp->name);
-    nc3=xmlNewText(BAD_CAST _ss(tmp->value));
-    xmlAddChild(nc2,nc3);  
-    xmlAddChild(nc1,nc2);
-    xmlAddChild(nc,nc1);
-  }
+    tmp = getMap (m->content, "Abstract");
+  if (tmp != NULL)
+    {
+      nc2 = xmlNewNode (ns_ows, BAD_CAST tmp->name);
+      nc3 = xmlNewText (BAD_CAST _ss (tmp->value));
+      xmlAddChild (nc2, nc3);
+      xmlAddChild (nc1, nc2);
+      xmlAddChild (nc, nc1);
+    }
 
   /**
@@ -1814,68 +2166,86 @@
    */
 #ifdef DEBUG
-  fprintf(stderr,"FORMAT %s %s\n",e->format,e->format);
-#endif
-  map *tmpMap=getMap(m->content,"Reference");
-  if(tmpMap==NULL){
-    nc2=xmlNewNode(ns_wps, BAD_CAST "Data");
-    if(e!=NULL){
-      if(strncasecmp(e->format,"LiteralOutput",strlen(e->format))==0)
-	nc3=xmlNewNode(ns_wps, BAD_CAST "LiteralData");
+  fprintf (stderr, "FORMAT %s %s\n", e->format, e->format);
+#endif
+  map *tmpMap = getMap (m->content, "Reference");
+  if (tmpMap == NULL)
+    {
+      nc2 = xmlNewNode (ns_wps, BAD_CAST "Data");
+      if (e != NULL)
+        {
+          if (strncasecmp (e->format, "LiteralOutput", strlen (e->format)) ==
+              0)
+            nc3 = xmlNewNode (ns_wps, BAD_CAST "LiteralData");
+          else
+            if (strncasecmp (e->format, "ComplexOutput", strlen (e->format))
+                == 0)
+            nc3 = xmlNewNode (ns_wps, BAD_CAST "ComplexData");
+          else
+            if (strncasecmp
+                (e->format, "BoundingBoxOutput", strlen (e->format)) == 0)
+            nc3 = xmlNewNode (ns_wps, BAD_CAST "BoundingBoxData");
+          else
+            nc3 = xmlNewNode (ns_wps, BAD_CAST e->format);
+        }
       else
-	if(strncasecmp(e->format,"ComplexOutput",strlen(e->format))==0)
-	  nc3=xmlNewNode(ns_wps, BAD_CAST "ComplexData");
-	else if(strncasecmp(e->format,"BoundingBoxOutput",strlen(e->format))==0)
-	  nc3=xmlNewNode(ns_wps, BAD_CAST "BoundingBoxData");
-	else
-	  nc3=xmlNewNode(ns_wps, BAD_CAST e->format);
-    }
-    else{
-      map* tmpV=getMapFromMaps(m,"format","value");
-      if(tmpV!=NULL)
-	nc3=xmlNewNode(ns_wps, BAD_CAST tmpV->value);
+        {
+          map *tmpV = getMapFromMaps (m, "format", "value");
+          if (tmpV != NULL)
+            nc3 = xmlNewNode (ns_wps, BAD_CAST tmpV->value);
+          else
+            nc3 = xmlNewNode (ns_wps, BAD_CAST "LitteralData");
+        }
+      tmp = m->content;
+#ifdef USE_MS
+      map *testMap = getMap (tmp, "requestedMimeType");
+#endif
+      while (tmp != NULL)
+        {
+          if (strcasecmp (tmp->name, "mimeType") == 0 ||
+              strcasecmp (tmp->name, "encoding") == 0 ||
+              strcasecmp (tmp->name, "schema") == 0 ||
+              strcasecmp (tmp->name, "datatype") == 0 ||
+              strcasecmp (tmp->name, "uom") == 0)
+            {
+#ifdef USE_MS
+              if (testMap == NULL
+                  || (testMap != NULL
+                      && strncasecmp (testMap->value, "text/xml", 8) == 0))
+                {
+#endif
+                  xmlNewProp (nc3, BAD_CAST tmp->name, BAD_CAST tmp->value);
+#ifdef USE_MS
+                }
+              else if (strcasecmp (tmp->name, "mimeType") == 0)
+                {
+                  if (testMap != NULL)
+                    xmlNewProp (nc3, BAD_CAST tmp->name,
+                                BAD_CAST testMap->value);
+                  else
+                    xmlNewProp (nc3, BAD_CAST tmp->name, BAD_CAST tmp->value);
+                }
+#endif
+            }
+          tmp = tmp->next;
+          xmlAddChild (nc2, nc3);
+        }
+      if (e != NULL && e->format != NULL
+          && strcasecmp (e->format, "BoundingBoxData") == 0)
+        {
+          map *bb = getMap (m->content, "value");
+          if (bb != NULL)
+            {
+              map *tmpRes = parseBoundingBox (bb->value);
+              printBoundingBox (ns_ows, nc3, tmpRes);
+              freeMap (&tmpRes);
+              free (tmpRes);
+            }
+        }
       else
-	nc3=xmlNewNode(ns_wps, BAD_CAST "LitteralData");
-    } 
-    tmp=m->content;
-#ifdef USE_MS
-    map* testMap=getMap(tmp,"requestedMimeType");
-#endif
-    while(tmp!=NULL){
-      if(strcasecmp(tmp->name,"mimeType")==0 ||
-	 strcasecmp(tmp->name,"encoding")==0 ||
-	 strcasecmp(tmp->name,"schema")==0 ||
-	 strcasecmp(tmp->name,"datatype")==0 ||
-	 strcasecmp(tmp->name,"uom")==0){
-#ifdef USE_MS
-	if(testMap==NULL || (testMap!=NULL && strncasecmp(testMap->value,"text/xml",8)==0)){
-#endif
-	  xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST tmp->value);
-#ifdef USE_MS
-	}
-	else
-	  if(strcasecmp(tmp->name,"mimeType")==0){
-	    if(testMap!=NULL)
-	      xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST testMap->value);
-	    else 
-	      xmlNewProp(nc3,BAD_CAST tmp->name,BAD_CAST tmp->value);
-	  }
-#endif
-      }
-      tmp=tmp->next;
-      xmlAddChild(nc2,nc3);
-    }
-    if(e!=NULL && e->format!=NULL && strcasecmp(e->format,"BoundingBoxData")==0){
-      map* bb=getMap(m->content,"value");
-      if(bb!=NULL){
-	map* tmpRes=parseBoundingBox(bb->value);
-	printBoundingBox(ns_ows,nc3,tmpRes);
-	freeMap(&tmpRes);
-	free(tmpRes);
-      }
-    }else{
-      if(e!=NULL)
-	tmp=getMap(e->defaults->content,"mimeType");
-      else
-	tmp=NULL;
+        {
+          if (e != NULL)
+            tmp = getMap (e->defaults->content, "mimeType");
+          else
+            tmp = NULL;
 #ifdef USE_MS
       /**
